function getTask(name) {
    for (let thread of threads) {
        const result = thread.subtasks.find(task => task.task == name)
        if (result != undefined) return result;
    }
}

function getThread(name) {
    return threads.find(thread => thread.name == name);
}

function open(e) {
    var file = e.target.files[0];
    if (!file) {
        return;
    }
    var reader = new FileReader();
    reader.onload = function (e) {
        var contents = e.target.result;
        saveToCookies();
        threads = JSON.parse(contents);
        configuration.currentProject = prompt("What is the imported projects name?")
        if (!configuration.projects.includes(configuration.currentProject)) { //If we don't already have a project of that name.
            configuration.projects.push(configuration.currentProject); //Add it to the list.
        }
        saveToCookies(); //Save the new imported project.
        update();
    };
    reader.readAsText(file);
}

document.getElementById('file-input').addEventListener('change', open, false);

function save() {
    var dataStr = "data:text/json;charset=utf-8," + encodeURIComponent(JSON.stringify(threads));
    var dlAnchorElem = document.getElementById('downloadAnchorElem');
    dlAnchorElem.setAttribute("href", dataStr);
    dlAnchorElem.setAttribute("download", "ThreadData.json");
    dlAnchorElem.click();
}

function saveToCookies() {
    localStorage.setItem(configuration.currentProject, JSON.stringify(threads));
}


function loadFromCookies() {

    data_threads = JSON.parse(localStorage.getItem("data"));
    if (data_threads) { //we need to upgrade the version
        p_name = ""
        while (!p_name || p_name == "")
            p_name = prompt("Detected Project on the old version. Please name this project:")
        configuration.currentProject = p_name;
        configuration.projects.push(p_name);
        localStorage.setItem(p_name, JSON.stringify(data_threads));
        threads = data_threads;
        alert("Successfully saved to projects as " + p_name);
        saveConfiguration()
        localStorage.removeItem("data");
        //todo delete the stuff stored at "data"
    } else
        threads = JSON.parse(localStorage.getItem(configuration.currentProject));
    console.log(threads)
    update();
}

Array.prototype.last = function () {
    return this[this.length - 1];
}

function loadConfiguration() {
    configuration = JSON.parse(localStorage.getItem("__configuration"));
    if (!configuration?.currentProject) { //No configuration found
        newProjectName = prompt("No data found. Please start a new project. What would you like this project to be called?")
        configuration = {
            "currentProject": newProjectName,
            "projects": [newProjectName]
        }
        saveConfiguration(); //Save this new config to cookies.
        saveToCookies(); //Save this empty project to cookies.
    }
}

function saveConfiguration() {
    localStorage.setItem("__configuration", JSON.stringify(configuration));
}

function changeProject() {
    saveToCookies();
    configuration.currentProject = $('#pro').val();
    loadFromCookies(); //Automatically calls update.
}


function renameCurrentProject() {
    //Save as new, delete old, edit configuration, reload all.
    const newName = $('#pname').val();
    const oldName = configuration.currentProject;
    configuration.currentProject = newName;
    saveToCookies();
    localStorage.removeItem(oldName);
    configuration.projects = configuration.projects.filter(e => e != oldName)
    configuration.projects.push(newName); //Add that bad boy to the list.
    saveConfiguration();
    update();
    $('#rn').hide();
}

function newProject() {
    saveToCookies();
    const newName = prompt("What is the new project name?");
    configuration.currentProject = newName;
    configuration.projects.push(newName); //Add that bad boy to the list.
    saveConfiguration();
    threads = [];
    saveToCookies();
    update();
}

function delProject() {
    if (confirm("Are you sure you want to delete Project " + configuration.currentProject)) {
        //Remove this project from the list of projects. If there are remaining projects, set the current one to the first remaining one.
        const oldName = configuration.currentProject;
        localStorage.removeItem(oldName);
        configuration.projects = configuration.projects.filter(e => e != oldName)
        configuration.currentProject = configuration.projects.length > 1 ? configuration.projects[0] : "";
        saveConfiguration();
        threads = JSON.parse(localStorage.getItem(configuration.currentProject));
        update();
        $('#rn').hide();
    }
}