
function addThread() {
    on();
    $("#menu_name").html("Add Thread");
    $("#menu_dropdown").hide();
    $('#selectDep2').hide();
    $("#preview").html('<div>Enter line break separated tasks to be added to this task.</div><textarea name="" id="enterAll" cols="68" rows="5" ></textarea>')
    $("#done").unbind("click");
    $("#done").click(function () {
        if (getThread($('#text').val())) {
            alert("A Thread already exists named " + $('#text').val())
            return
        }
        if ($("#enterAll").val() != "") {
            st = $("#enterAll").val().split("\n")
            st = st.map((e, i) => {
                e = e.trim();
                if (e.charAt(0) == '-') {
                    e = e.substring(1);
                }
                e = e.trim()
                st[i] = e;
                console.log(e);
                const blockedBy = i > 0 ? st[i - 1] : null;
                return { task: e, blockedBy: blockedBy, done: false }
            })
            threads.push({ name: $('#text').val(), subtasks: st });
        } else
            threads.push({ name: $('#text').val(), subtasks: [] });
        update();
        off();
    })
}

function addTask() {
    if (threads.length == 0) {
        alert("Add a thread first");
        return;
    }
    on();
    $("#menu_name").html("Add Task");
    $("#menu_dropdown").show();
    var options = $('#menu_dropdown');
    options.empty();
    $('#selectDep2').show();
    var options1 = $('#selectDep2');
    options1.empty();

    threads.forEach((e) => {
        options.append(new Option(e.name, e.name, true, true));
    })
    options.change(function () {
        const graphic = generateGraphic(options.val());
        $("#preview").html(graphic);
        options1.val(getThread(options.val()).subtasks[0]);
    })
    options.change();
    $("#done").unbind("click");
    $("#done").click(function () {
        if ($('#text').val() != "") {
            thread = getThread(options.val());
            thread.subtasks.push({ task: $('#text').val(), blockedBy: $('#selectDep2').val(), done: false });
            options.change();
            options1.empty();
            document.getElementById("preview").scrollTop += 20;
            options1.html(generateBlockingTasksList(thread.subtasks.last().task))
            update();
            $('#text').val("");
        }
    })

    $('#text').on("keyup", function (e) {
        if (e.keyCode == 13) {
            $("#done").click();
        }
    });

    options1.html(generateBlockingTasksList(undefined))
    options1.val(getThread(options.val()).subtasks.last());
}

function editTask(e) {


    task = getTask(e);
    $('#taskDate').val(task.date);
    $('#overlay2').show();
    $('#editText').val(task.task);
    $("#doneEdit").unbind("click");

    $('#doneEdit').click(() => {
        const newText = $('#editText').val();
        threads.forEach((thread) => {
            thread.subtasks.forEach((element) => {
                if (element.blockedBy == task.task) {
                    element.blockedBy = newText;
                }
            })
        })
        task.task = newText;
        task.date = $('#taskDate').val();
        task.blockedBy = $('#selectDep').val();
        $('#overlay2').hide();
        document.onkeydown = undefined;
        update();
    })
    document.onkeydown = (e) => {
        if (e.key == "Enter" && e.ctrlKey) {
            $('#doneEdit').click();
        }
        if (e.key == "Escape") {
            off();
        }
    }
    $("#markDone").unbind("click");
    if (task.done) {
        $("#markDone").html("Set Un-done")

        $("#markDone").click(() => {
            task.done = false;
            $('#overlay2').hide();
            update();
        })
    } else {
        $("#markDone").html("Set Done")
        $("#markDone").click(() => {
            task.done = true;
            $('#overlay2').hide();
            update();
        })
    }
    $("#delete").unbind("click");
    $('#delete').click(() => {
        removeTask(task.task);
        $('#overlay2').hide();
    })

    $("#statusss").html("Task is currently " + (task.done ? "completed." : "not completed.") + " Blocked by " + task.blockedBy)
    var options = $('#selectDep');
    options.html(generateBlockingTasksList(task))
    options.val(task.blockedBy != undefined ? task.blockedBy : "");

}

function removeTask(e) {
    threads.forEach((thread) => {
        thread.subtasks = thread.subtasks.filter((subtask) => subtask.task != e);
    })
    threads.forEach((thread) => {
        thread.subtasks.forEach((element) => {
            if (element.blockedBy == e) {
                element.blockedBy = undefined;
            }
        })
    })
    update();
}

function swapDone(e) {
    getTask(e).done = true;
    update();
}

$('body').click(function (e) {
    let target = $(e.target);
    if (e.target.localName == "li" && $("#overlay").is(":hidden") && $("#overlay2").is(":hidden"))
        editTask(target.html());
});