function update() {
    //Update pro with the list of projects, then set the current project the selected project
    $('#pro').empty();
    configuration.projects.forEach(e => $('#pro').append(new Option(e, e)))
    $('#pro').val(configuration.currentProject);
    $('#pname').val(configuration.currentProject);
    //Set the name of the input project box.

    const states = ["blocked", "todo", "finished"];
    const columns = states.map(function (e) {
        return $("#" + e);
    });
    columns.forEach((e) => e.empty());

    if (!(Symbol.iterator in Object(threads))) return

    for (let thread of threads) {
        for (let i = 0; i < states.length; i++) {
            // Move any part of the thread that is finished to the finished list.
            let subDiv = document.createElement("div");
            let title = document.createElement("h3")
            title.innerHTML = thread.name;
            subDiv.append(title);
            let graphic = generateGraphic(thread.name, states[i])
            if (graphic) {
                subDiv.append(graphic);
                columns[i].append(subDiv);
            }
        }
    }
    saveToCookies();
}

function generateGraphic(name, type = "all") {
    let now = new Date();
    now.setHours(0);
    now.setMinutes(0);
    now.setSeconds(0);
    now.setMilliseconds(0);

    let numAdded = 0;
    items = getThread(name).subtasks;
    const ul = document.createElement('ul');
    items.forEach(function (item) {

        let blocked;
        if (item.blockedBy) //is it blocked by something of interest? If so, we need to check if that task is done. If it is anything but done, we are still blocked.
            blocked = getTask(item.blockedBy).done != true;
        else blocked = false;

        if (type == "blocked" && (!blocked || item.done)) return; //If we are looking for blocked, if it isn't blocked or its done forget it.
        if (type == "todo" && (blocked || item.done)) return;     //If we are looking for todo, if is blocked or its done forget it
        if (type == "finished" && !item.done) return;             //If we are looking for done, then if it isn't done forget it.

        let li = document.createElement('li');
        ul.appendChild(li);
        numAdded++;

        li.innerHTML += item.task;
        if (type == "blocked") {
            const blockedText = document.createElement('small')
            blockedText.innerHTML = "Blocked by: " + item.blockedBy.substring(0, 40);
            ul.appendChild(blockedText);
        }
        if (type != 'finished' && item.date) {
            const dateText = document.createElement('i');
            dateText.innerHTML = " - " + humanizeDuration(new Date(item.date.replaceAll('-', '/')) - now, { largest: 1, units: ['y', 'mo', 'w', 'd'], round: true });
            if (new Date(item.date.replaceAll('-', '/')) - now < 0) {
                dateText.innerHTML += ' ago';
            }
            ul.appendChild(dateText);
        }
    });
    if (numAdded == 0) return false;
    return ul;
}

function generateBlockingTasksList(excluding) {

    holder = document.createElement('select')

    holder.append(new Option("Not Blocked", "", false, false))
    threads.forEach((t) => {
        // if (t.length != 0) {
        if (t.subtasks.filter(task => !task.done).length > 0) {
            let group = document.createElement("OPTGROUP");
            group.setAttribute('label', t.name);
            holder.append(group);
            t.subtasks.forEach((e) => {
                if (!excluding || e.task != excluding.task) {
                    if (!e.done)
                        group.append(new Option(e.task, e.task, false, false))
                }
            });
        }
        // }
    })


    return holder.innerHTML;
}

function on() {
    $("#overlay").show();
}
function off() {
    $("#overlay").hide();
    $("#overlay2").hide();
}
off();
$('#rn').hide();